// The MIT License
//
// Copyright (c) 2020 Temporal Technologies Inc.  All rights reserved.
//
// Copyright (c) 2020 Uber Technologies, Inc.
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

// Code generated by MockGen. DO NOT EDIT.
// Source: archivalMetadata.go

// Package archiver is a generated GoMock package.
package archiver

import (
	reflect "reflect"

	gomock "github.com/golang/mock/gomock"
	v1 "go.temporal.io/api/enums/v1"
)

// MockArchivalMetadata is a mock of ArchivalMetadata interface.
type MockArchivalMetadata struct {
	ctrl     *gomock.Controller
	recorder *MockArchivalMetadataMockRecorder
}

// MockArchivalMetadataMockRecorder is the mock recorder for MockArchivalMetadata.
type MockArchivalMetadataMockRecorder struct {
	mock *MockArchivalMetadata
}

// NewMockArchivalMetadata creates a new mock instance.
func NewMockArchivalMetadata(ctrl *gomock.Controller) *MockArchivalMetadata {
	mock := &MockArchivalMetadata{ctrl: ctrl}
	mock.recorder = &MockArchivalMetadataMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockArchivalMetadata) EXPECT() *MockArchivalMetadataMockRecorder {
	return m.recorder
}

// GetHistoryConfig mocks base method.
func (m *MockArchivalMetadata) GetHistoryConfig() ArchivalConfig {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetHistoryConfig")
	ret0, _ := ret[0].(ArchivalConfig)
	return ret0
}

// GetHistoryConfig indicates an expected call of GetHistoryConfig.
func (mr *MockArchivalMetadataMockRecorder) GetHistoryConfig() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetHistoryConfig", reflect.TypeOf((*MockArchivalMetadata)(nil).GetHistoryConfig))
}

// GetVisibilityConfig mocks base method.
func (m *MockArchivalMetadata) GetVisibilityConfig() ArchivalConfig {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetVisibilityConfig")
	ret0, _ := ret[0].(ArchivalConfig)
	return ret0
}

// GetVisibilityConfig indicates an expected call of GetVisibilityConfig.
func (mr *MockArchivalMetadataMockRecorder) GetVisibilityConfig() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetVisibilityConfig", reflect.TypeOf((*MockArchivalMetadata)(nil).GetVisibilityConfig))
}

// MockArchivalConfig is a mock of ArchivalConfig interface.
type MockArchivalConfig struct {
	ctrl     *gomock.Controller
	recorder *MockArchivalConfigMockRecorder
}

// MockArchivalConfigMockRecorder is the mock recorder for MockArchivalConfig.
type MockArchivalConfigMockRecorder struct {
	mock *MockArchivalConfig
}

// NewMockArchivalConfig creates a new mock instance.
func NewMockArchivalConfig(ctrl *gomock.Controller) *MockArchivalConfig {
	mock := &MockArchivalConfig{ctrl: ctrl}
	mock.recorder = &MockArchivalConfigMockRecorder{mock}
	return mock
}

// EXPECT returns an object that allows the caller to indicate expected use.
func (m *MockArchivalConfig) EXPECT() *MockArchivalConfigMockRecorder {
	return m.recorder
}

// ClusterConfiguredForArchival mocks base method.
func (m *MockArchivalConfig) ClusterConfiguredForArchival() bool {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "ClusterConfiguredForArchival")
	ret0, _ := ret[0].(bool)
	return ret0
}

// ClusterConfiguredForArchival indicates an expected call of ClusterConfiguredForArchival.
func (mr *MockArchivalConfigMockRecorder) ClusterConfiguredForArchival() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "ClusterConfiguredForArchival", reflect.TypeOf((*MockArchivalConfig)(nil).ClusterConfiguredForArchival))
}

// GetClusterState mocks base method.
func (m *MockArchivalConfig) GetClusterState() ArchivalState {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetClusterState")
	ret0, _ := ret[0].(ArchivalState)
	return ret0
}

// GetClusterState indicates an expected call of GetClusterState.
func (mr *MockArchivalConfigMockRecorder) GetClusterState() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetClusterState", reflect.TypeOf((*MockArchivalConfig)(nil).GetClusterState))
}

// GetNamespaceDefaultState mocks base method.
func (m *MockArchivalConfig) GetNamespaceDefaultState() v1.ArchivalState {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetNamespaceDefaultState")
	ret0, _ := ret[0].(v1.ArchivalState)
	return ret0
}

// GetNamespaceDefaultState indicates an expected call of GetNamespaceDefaultState.
func (mr *MockArchivalConfigMockRecorder) GetNamespaceDefaultState() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetNamespaceDefaultState", reflect.TypeOf((*MockArchivalConfig)(nil).GetNamespaceDefaultState))
}

// GetNamespaceDefaultURI mocks base method.
func (m *MockArchivalConfig) GetNamespaceDefaultURI() string {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "GetNamespaceDefaultURI")
	ret0, _ := ret[0].(string)
	return ret0
}

// GetNamespaceDefaultURI indicates an expected call of GetNamespaceDefaultURI.
func (mr *MockArchivalConfigMockRecorder) GetNamespaceDefaultURI() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "GetNamespaceDefaultURI", reflect.TypeOf((*MockArchivalConfig)(nil).GetNamespaceDefaultURI))
}

// ReadEnabled mocks base method.
func (m *MockArchivalConfig) ReadEnabled() bool {
	m.ctrl.T.Helper()
	ret := m.ctrl.Call(m, "ReadEnabled")
	ret0, _ := ret[0].(bool)
	return ret0
}

// ReadEnabled indicates an expected call of ReadEnabled.
func (mr *MockArchivalConfigMockRecorder) ReadEnabled() *gomock.Call {
	mr.mock.ctrl.T.Helper()
	return mr.mock.ctrl.RecordCallWithMethodType(mr.mock, "ReadEnabled", reflect.TypeOf((*MockArchivalConfig)(nil).ReadEnabled))
}
